Package weka.experiment

# Class RegressionSplitEvaluator

java.lang.Object
weka.experiment.RegressionSplitEvaluator

All Implemented Interfaces:
  `Serializable`, `AdditionalMeasureProducer`, `OptionHandler`, `RevisionHandler`, `SplitEvaluator`

public class RegressionSplitEvaluator extends Object implements SplitEvaluator, OptionHandler, AdditionalMeasureProducer, RevisionHandler
A SplitEvaluator that produces results for a classification scheme on a numeric class attribute.

Valid options are:

     -W <class name>
      The full class name of the classifier.
      eg: weka.classifiers.bayes.NaiveBayes

     Options specific to classifier weka.classifiers.rules.ZeroR:

     -D
      If set, classifier is run in debug mode and
      may output additional info to the console

Version:
  $Revision: 11198 $
Author:
  Len Trigg (trigg@cs.waikato.ac.nz)
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`RegressionSplitEvaluator()`
No args constructor.

## Method Summary

Modifier and Type
Method
Description
`String`
`classifierTipText()`
Returns the tip text for this property
`Enumeration`
`enumerateMeasures()`
Returns an enumeration of any additional measure names that might be in the classifier
`Classifier`
`getClassifier()`
Get the value of Classifier.
`Object[]`
`getKey()`
Gets the key describing the current SplitEvaluator.
`String[]`
`getKeyNames()`
Gets the names of each of the key columns produced for a single run.
`Object[]`
`getKeyTypes()`
Gets the data types of each of the key columns produced for a single run.
`double`
`getMeasure(String additionalMeasureName)`
Returns the value of the named measure
`String[]`
`getOptions()`
Gets the current settings of the Classifier.
`String`
`getRawResultOutput()`
Gets the raw output from the classifier
`Object[]`
`getResult(Instances train, Instances test)`
Gets the results for the supplied train and test datasets.
`String[]`
`getResultNames()`
Gets the names of each of the result columns produced for a single run.
`Object[]`
`getResultTypes()`
Gets the data types of each of the result columns produced for a single run.
`String`
`getRevision()`
Returns the revision string.
`String`
`globalInfo()`
Returns a string describing this split evaluator
`Enumeration`
`listOptions()`
Returns an enumeration describing the available options..
`void`
`setAdditionalMeasures(String[] additionalMeasures)`
Set a list of method names for additional measures to look for in Classifiers.
`void`
`setClassifier(Classifier newClassifier)`
Sets the classifier.
`void`
`setClassifierName(String newClassifierName)`
Set the Classifier to use, given it's class name.
`void`
`setOptions(String[] options)`
Parses a given list of options.
`String`
`toString()`
Returns a text description of the split evaluator.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### RegressionSplitEvaluator

public RegressionSplitEvaluator()
No args constructor.

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this split evaluator

Returns:
  a description of the split evaluator suitable for displaying in the explorer/experimenter gui

### listOptions

public Enumeration listOptions()
Returns an enumeration describing the available options..

Specified by:
  `listOptions` in interface `OptionHandler`
Returns:
  an enumeration of all the available options.

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Valid options are:

     -W <class name>
      The full class name of the classifier.
      eg: weka.classifiers.bayes.NaiveBayes

     Options specific to classifier weka.classifiers.rules.ZeroR:

     -D
      If set, classifier is run in debug mode and
      may output additional info to the console

All option after -- will be passed to the classifier.

Specified by:
  `setOptions` in interface `OptionHandler`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### getOptions

public String[] getOptions()
Gets the current settings of the Classifier.

Specified by:
  `getOptions` in interface `OptionHandler`
Returns:
  an array of strings suitable for passing to setOptions

### setAdditionalMeasures

public void setAdditionalMeasures(String[] additionalMeasures)
Set a list of method names for additional measures to look for in Classifiers. This could contain many measures (of which only a subset may be produceable by the current Classifier) if an experiment is the type that iterates over a set of properties.

Specified by:
  `setAdditionalMeasures` in interface `SplitEvaluator`
Parameters:
  `additionalMeasures` - an array of method names.

### enumerateMeasures

public Enumeration enumerateMeasures()
Returns an enumeration of any additional measure names that might be in the classifier

Specified by:
  `enumerateMeasures` in interface `AdditionalMeasureProducer`
Returns:
  an enumeration of the measure names

### getMeasure

public double getMeasure(String additionalMeasureName)
Returns the value of the named measure

Specified by:
  `getMeasure` in interface `AdditionalMeasureProducer`
Parameters:
  `additionalMeasureName` - the name of the measure to query for its value
Returns:
  the value of the named measure
Throws:
  `IllegalArgumentException` - if the named measure is not supported

### getKeyTypes

public Object[] getKeyTypes()
Gets the data types of each of the key columns produced for a single run. The number of key fields must be constant for a given SplitEvaluator.

Specified by:
  `getKeyTypes` in interface `SplitEvaluator`
Returns:
  an array containing objects of the type of each key column. The objects should be Strings, or Doubles.

### getKeyNames

public String[] getKeyNames()
Gets the names of each of the key columns produced for a single run. The number of key fields must be constant for a given SplitEvaluator.

Specified by:
  `getKeyNames` in interface `SplitEvaluator`
Returns:
  an array containing the name of each key column

### getKey

public Object[] getKey()
Gets the key describing the current SplitEvaluator. For example This may contain the name of the classifier used for classifier predictive evaluation. The number of key fields must be constant for a given SplitEvaluator.

Specified by:
  `getKey` in interface `SplitEvaluator`
Returns:
  an array of objects containing the key.

### getResultTypes

public Object[] getResultTypes()
Gets the data types of each of the result columns produced for a single run. The number of result fields must be constant for a given SplitEvaluator.

Specified by:
  `getResultTypes` in interface `SplitEvaluator`
Returns:
  an array containing objects of the type of each result column. The objects should be Strings, or Doubles.

### getResultNames

public String[] getResultNames()
Gets the names of each of the result columns produced for a single run. The number of result fields must be constant for a given SplitEvaluator.

Specified by:
  `getResultNames` in interface `SplitEvaluator`
Returns:
  an array containing the name of each result column

### getResult

public Object[] getResult(Instances train, Instances test) throws Exception
Gets the results for the supplied train and test datasets. Now performs a deep copy of the classifier before it is built and evaluated (just in case the classifier is not initialized properly in buildClassifier()).

Specified by:
  `getResult` in interface `SplitEvaluator`
Parameters:
  `train` - the training Instances.
  `test` - the testing Instances.
Returns:
  the results stored in an array. The objects stored in the array may be Strings, Doubles, or null (for the missing value).
Throws:
  `Exception` - if a problem occurs while getting the results

### classifierTipText

public String classifierTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### getClassifier

public Classifier getClassifier()
Get the value of Classifier.

Returns:
  Value of Classifier.

### setClassifier

public void setClassifier(Classifier newClassifier)
Sets the classifier.

Parameters:
  `newClassifier` - the new classifier to use.

### setClassifierName

public void setClassifierName(String newClassifierName) throws Exception
Set the Classifier to use, given it's class name. A new classifier will be instantiated.

Parameters:
  `newClassifierName` - the Classifier class name.
Throws:
  `Exception` - if the class name is invalid.

### getRawResultOutput

public String getRawResultOutput()
Gets the raw output from the classifier

Specified by:
  `getRawResultOutput` in interface `SplitEvaluator`
Returns:
  the raw output from the classifier

### toString

public String toString()
Returns a text description of the split evaluator.

Overrides:
  `toString` in class `Object`
Returns:
  a text description of the split evaluator.

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Returns:
  the revision